//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
void __fastcall TForm1::MainLoop(TObject* Sender, bool& Done)
{
iteration++;

Label1->Caption = "Running, iter=="+IntToStr(iteration)+", z=="+IntToStr(iteration%zmax);
PaintNeurons( iteration % zmax );

Done = IterateNeuralNetwork();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PaintNeurons( int z )
{
for (int x=0;x<xmax;x++)
	for (int y=0;y<ymax;y++)
    	{
        for (int x1=0;x1<10;x1++)
        	for (int y1=0;y1<10;y1++)
            	{
		        Canvas->Pixels[x*10+x1+400+z*5][y*10+y1+z*5] = GetNeuron( x, y, z );
                }
        }
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::SetAllNeurons( byte value )
{
for (int z=0; z<zmax; z++)
	for (int x=0; x<xmax; x++)
		for (int y=0; y<ymax; y++)
            SetNeuron( x, y, z, value );
return true;
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::LoadNeuronsFromFile( AnsiString filename )
{
// this loads a file into z=0
TStringList* strings = new TStringList();
if (strings)
	{
    strings->LoadFromFile( filename );
    }

for (int row=0;row<strings->Count;row++)
	{
    for (int pos=0;pos<strings->Strings[row].Length();pos++)
    	{
        byte character = strings->Strings[row].c_str()[pos];
        Label1->Caption = Label1->Caption + character;
        Label1->Update();
        SetNeuron( pos, row, 0, character );
        }
    }
if (strings) delete strings;
return true;
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::SetNeuron( int x, int y, int z, byte value )
{
int pos = x * xmax * ymax +  y * ymax + z;
neuron[pos] = value;
return (bool) value;
}
//---------------------------------------------------------------------------
byte __fastcall TForm1::GetNeuron( int x, int y, int z )
{
int pos = x * xmax * ymax +  y * ymax + z;
return neuron[pos];
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::IterateNeuralNetwork()
{
int x=0;
int y=0;
int z=0;

// for each frame, from north to south, make each neuron fire in turn
// z==0, north
// z==zmax, south
for (z=0; z<zmax-1; z++)
	{
	Label1->Caption = "Iterating Neurons Layer #"+IntToStr(z);
	Label1->Update();

	for (x=0; x<xmax; x++)
		for (y=0; y<ymax; y++)

		    // make each neuron fire in turn
            {

            FireNeuron( x, y, z );

            }

    PaintNeurons( z );
    }

// now display the result
return true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FireNeuron( int x, int y, int z )
{
int threshold = GetNeuron( x, y, z );
if (threshold<100)
   	{
    // do not fire
    }
else
	{
    // fire for all on the next layer
	for (int x1=0; x1<xmax; x1+=10)
		for (int y1=0; y1<ymax; y1+=10)
	    	{
            // fire down 10 dendrites
            SetNeuron( x1, y1, z+1, GetNeuron( x, y, z )  );
            }
    }
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
Label1->Caption = "n/a";
WindowState = wsMaximized;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
AnsiString filename = "Unit1.cpp";

Label1->Caption = "Started";
Label1->Update();

Label1->Caption = "Clearing Neurons";
Label1->Update();
SetAllNeurons( 0 );
PaintNeurons( 0 );

Label1->Caption = "Loading Neurons from File :- "+filename;
Label1->Update();
LoadNeuronsFromFile( filename );
PaintNeurons( 0 );

Label1->Caption = "Starting MainLoop()";
Label1->Update();

Application->OnIdle = MainLoop;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
Application->OnIdle = NULL;
Label1->Caption = "Stopped";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
for (int z=0;z<zmax;z++)
	{
	PaintNeurons( z );
    }
}
//---------------------------------------------------------------------------
